valentin/interviews/urls.py
from django.urls import path
from . import views

app_name = "interviews"

urlpatterns = [
    path(
        "profile/", views.InterviewerProfileEditView.as_view(), name="profile"
    ),
    path("sessions/", views.SessionListView.as_view(), name="list"),
    path(
        "<uuid:session_id>/dispo-select/",
        views.InterviewerDispoSelect.as_view(),
        name="dispo-select",
    ),
    path(
        "<uuid:session_id>/slot-select/",
        views.ContestantSlotSelect.as_view(),
        name="slot-select",
    ),
    path(
        "<uuid:session_id>/recap/",
        views.InterviewRecapView.as_view(),
        name="contestant-recap",
    ),
    path(
        "<uuid:session_id>/my-itw/",
        views.ContestantInterviewPortal.as_view(),
        name="contestant-portal",
    ),
    path(
        "<uuid:session_id>/my-itws/",
        views.InterviewerSlotsList.as_view(),
        name="interviewer-interviews",
    ),
    path(
        "<uuid:session_id>/grading/<int:contestant_id>/",
        views.ContestantGrading.as_view(),
        name="contestant-grading",
    ),
]

valentin/semifinals/urls.py
from django.urls import path
from django.contrib.auth.views import LoginView, LogoutView
from . import views

app_name = "semifinals"

urlpatterns = [
    path("login/", LoginView.as_view(), name="login"),
    path("logout/", LogoutView.as_view(next_page="/"), name="logout"),
    path("sessions/", views.SessionList.as_view(), name="session-list"),
    path(
        "session/<uuid:pk>/",
        views.SessionDetail.as_view(),
        name="session-details",
    ),
    path(
        "session/<uuid:pk>/subject",
        views.DownloadSessionSubjectView.as_view(),
        name="download-subject",
    ),
    path(
        "overseer/",
        views.SessionOverseerList.as_view(),
        name="session-overseer-list",
    ),
    path(
        "overseer/<uuid:session_id>/",
        views.SessionOverseer.as_view(),
        name="session-overseer",
    ),
    path(
        "contestant/", views.HomeContestant.as_view(), name="contestant-home"
    ),
    path("organizer/", views.HomeOrganizer.as_view(), name="organizer-home"),
    path("", views.HomeView.as_view(), name="home"),
]

valentin/valentin/urls.py
from django.contrib import admin
from django.urls import path, include

admin.site.site_header = "Administration Demi-Finales Prologin"

urlpatterns = [
    path("admin/", admin.site.urls),
    path("written-exams/", include("written_exams.urls")),
    path("itw/", include("interviews.urls")),
    path("", include("semifinals.urls")),
    path("social/", include("social_django.urls", namespace="social")),
]

valentin/written_exams/urls.py
from django.urls import path
from . import views

app_name = "written_exams"

contestant_urls = [
    path(
        "submission/<uuid:session_id>/",
        views.contestant.SubmissionUploadView.as_view(),
        name="submit-file",
    ),
    path(
        "form/<uuid:id>/",
        views.contestant.FormSubmissionView.as_view(),
        name="form-questions",
    ),
    path(
        "form/<uuid:id>/review/",
        views.contestant.FormReviewView.as_view(),
        name="form-review",
    ),
]

staff_urls = [
    path(
        "staff/form/",
        views.staff.FormInstanceListView.as_view(),
        name="form-list",
    ),
    path(
        "staff/form/<uuid:id>/test",
        views.staff.FormTestingView.as_view(),
        name="form-testing",
    ),
    path(
        "staff/form/<uuid:id>/answers",
        views.staff.FormAnswersListView.as_view(),
        name="form-answers-list",
    ),
    path(
        "staff/form/<uuid:id>/export",
        views.staff.FormGlobalExportView.as_view(),
        name="form-export",
    ),
    path(
        "staff/form-answer/<int:id>",
        views.staff.FormAnswersDetailView.as_view(),
        name="form-answers",
    ),
    path(
        "staff/submissions/<uuid:session_id>",
        views.staff.FileSubmissionsListView.as_view(),
        name="submissions-list",
    ),
    path(
        "staff/submission/dl/<int:submission_id>",
        views.staff.FileSubmissionDownloadView.as_view(),
        name="submission-download",
    ),
]

urlpatterns = contestant_urls + staff_urls

valentin/semifinals/models.py
from django.db import models
from pathlib import Path
import uuid


def get_session_subject_path(obj, filename):
    return Path("session_subjects") / str(obj.id) / str(filename)


class SessionStatuses(models.IntegerChoices):
    NOT_PUBLISHED = 0
    TEASED = 1
    OPEN = 2
    SUBMISSIONS_CLOSED = 3


class Session(models.Model):
    id = models.UUIDField(
        primary_key=True, default=uuid.uuid4, verbose_name="ID"
    )
    upstream_id = models.IntegerField(
        help_text="ID de l'ER sur le site Prologin", null=True, blank=True
    )
    display_name = models.CharField(
        max_length=100, help_text="Nom affiché de la session"
    )
    date_start = models.DateTimeField(verbose_name="Début")
    date_end = models.DateTimeField(verbose_name="Fin")
    status = models.IntegerField(
        choices=SessionStatuses.choices, verbose_name="Statut"
    )
    subject = models.FileField(
        upload_to=get_session_subject_path, null=True, blank=True
    )
    contestant_instructions = models.TextField(max_length=1000)
    form = models.ForeignKey(
        to="se_forms.FormInstance",
        null=True,
        blank=True,
        on_delete=models.SET_NULL,
    )
    file_upload = models.BooleanField(
        verbose_name="Les participants doivent rendre un fichier"
    )
    subject_download_count = models.IntegerField(
        default=0, verbose_name="Nb. de téléchargements du sujet"
    )
    form_allow_review = models.BooleanField(
        verbose_name="Autoriser la relecture"
    )

    def __str__(self):
        return self.display_name

    @classmethod
    def get_user_sessions(cls, user):
        CONTESTANT_ALLOWED_STATUSES = (
            SessionStatuses.TEASED,
            SessionStatuses.OPEN,
            SessionStatuses.SUBMISSIONS_CLOSED,
        )
        if user.is_staff:
            return cls.objects.all()

        social = user.social_auth.first()
        if social is None:
            return cls.objects.filter(
                status__in=CONTESTANT_ALLOWED_STATUSES,
                upstream_id__isnull=True,
            )

        if (
            social.extra_data.get("is_contestant", False)
            and social.extra_data["contestant"].get("assignation_semifinal")
            == 2
        ):
            event_id = int(
                social.extra_data["contestant"]["assignation_semifinal_event"][
                    "id"
                ]
            )
            return cls.objects.filter(
                status__in=CONTESTANT_ALLOWED_STATUSES, upstream_id=event_id
            )

        return cls.objects.filter(
            status__in=CONTESTANT_ALLOWED_STATUSES, upstream_id__isnull=True
        )

valentin/semifinals/views.py
from django.views.generic import (
    ListView,
    DetailView,
    View,
    TemplateView,
    RedirectView,
)
from django.contrib.auth.mixins import LoginRequiredMixin
from django.conf import settings
from django.core.exceptions import ObjectDoesNotExist
from django.http import FileResponse, Http404, HttpResponse
from django.urls import reverse
from django.db.models import F
from django.shortcuts import get_object_or_404
from . import models
from valentin.utils import EnsureStaffMixin
from written_exams.models import Submission

from pathlib import Path

# overseer
from written_exams import models as we_models
from se_forms import models as se_models


class HomeView(LoginRequiredMixin, RedirectView):
    def get_redirect_url(self, *args, **kwargs):
        if self.request.user.is_staff:
            return reverse("semifinals:organizer-home")
        return reverse("semifinals:contestant-home")


class HomeContestant(LoginRequiredMixin, TemplateView):
    template_name = "semifinals/contestant-home.html"


class HomeOrganizer(EnsureStaffMixin, TemplateView):
    template_name = "semifinals/organizer-home.html"


class SessionList(LoginRequiredMixin, ListView):
    model = models.Session
    template_name = "semifinals/session-list.html"

    def get_queryset(self):
        return models.Session.get_user_sessions(self.request.user)


class SessionDetail(LoginRequiredMixin, DetailView):
    model = models.Session
    template_name = "semifinals/session-details.html"

    def get_queryset(self):
        DETAILS_ALLOWED_STATUSES = (
            models.SessionStatuses.OPEN,
            models.SessionStatuses.SUBMISSIONS_CLOSED,
        )
        return models.Session.get_user_sessions(self.request.user).filter(
            status__in=DETAILS_ALLOWED_STATUSES
        )

    def get_context_data(self, object, **kwargs):
        context = super().get_context_data(**kwargs)
        submission = None
        try:
            submission = Submission.objects.get(
                session=object, user=self.request.user
            )
        except ObjectDoesNotExist:
            pass

        context["submission"] = submission
        if object.form:
            context["form_user_answers"] = object.form.get_user_answers(
                self.request.user
            )

        return context


class DownloadSessionSubjectView(LoginRequiredMixin, View):
    http_method_names = ("get",)

    def get_x_accel(self, session):
        res = HttpResponse(status=200)
        res["X-Accel-Redirect"] = Path(settings.APP_X_ACCEL_PATH) / Path(
            session.subject.path
        ).relative_to(settings.MEDIA_ROOT)
        res["Content-Type"] = ""
        return res

    def get(self, request, pk, **kwargs):
        session = None
        try:
            session = models.Session.get_user_sessions(request.user).get(
                pk=pk, status=models.SessionStatuses.OPEN
            )
        except ObjectDoesNotExist:
            raise Http404()

        if not session.subject:
            raise Http404()

        if not request.user.is_staff:
            session.subject_download_count = F("subject_download_count") + 1
            session.save()

        if settings.APP_USE_X_ACCEL_REDIRECT:
            return self.get_x_accel(session)

        return FileResponse(
            open(session.subject.path, "rb"), as_attachment=True
        )


class SessionOverseerList(EnsureStaffMixin, ListView):
    model = models.Session
    template_name = "semifinals/session-overseer-list.html"


class SessionOverseer(EnsureStaffMixin, TemplateView):
    template_name = "semifinals/session-overseer.html"

    def get_context_data(self, session_id, **kwargs):
        context = super().get_context_data(**kwargs)
        session = get_object_or_404(models.Session, id=session_id)
        if session.file_upload:
            file_handouts = we_models.Submission.objects.filter(
                session=session
            )
            context["nb_file_handouts"] = file_handouts.count()
            context["last_file_handouts"] = file_handouts.order_by(
                "-last_updated"
            )[:15]

        if session.form is not None:
            form_instance = session.form
            answers = se_models.UserAnswers.objects.filter(form=form_instance)
            context["nb_form_handouts"] = answers.count()
            context["last_form_handouts"] = answers.order_by("-last_updated")[
                :15
            ]
            context["form"] = form_instance

        context["session"] = session

        return context

valentin/semifinals/templates/semifinals/base.html
{% load static %}
<html>
    <head>
        <meta charset="utf-8">
        <meta name="viewport" content="width=device-width, initial-scale=0.7">
        <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/line-awesome/1.3.0/line-awesome/css/line-awesome.min.css" integrity="sha512-vebUliqxrVkBy3gucMhClmyQP9On/HAWQdKDXRaAlb/FKuTbxkjPKUyqVOxAcGwFDka79eTF+YXwfke1h3/wfg==" crossorigin="anonymous" />
        <link rel="stylesheet" href="{% static 'semifinals/css/base.css' %}">
        {% block base_extra_head %}{% endblock %}
    </head>

    <body>
        <main>
        <div class="banner">
            <div class="banner-content">
                <img src="https://prologin.org/static/img/logo_cube.png" alt="Logo Prologin Cube" width="50" height="53">
                <span class="prologin-title">Prologin</span>
            </div>
        </div>
        {% block content %}{% endblock %}
        <br><br>
        {% block extra_body %}{% endblock %}
        </main>
        <footer class="sf-footer">
            <div class="container">
                <p class="footer-title">Made with 🦚 at Prologin</p>
                <small class="footer-app-name">VALENTIN : Véritable Application en Ligne pour Épreuves Notées et Interviews Nominatives</small>
            </div>
        </footer>
    </body>
</html>

valentin/semifinals/templates/semifinals/contestant-home.html
{% extends "semifinals/base.html" %}
{% load static %}

{% block base_extra_head %}
<title>Espace Candidat</title>
<link rel="stylesheet" href="{% static 'semifinals/css/home.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    {% if user.is_staff %}
    <small class="return-button"><a href="{% url 'semifinals:organizer-home' %}">&lt;&nbsp; Retour Espace Organisateur</a></small>
    {% endif %}
    <h1 class="{% if user.is_staff %}trb{% endif %}">Espace Candidat</h1>

    <p>Bienvenue dans votre espace candidat, <b>{{ user.first_name }} {{ user.last_name }}</b></p>

    <ul class="home-links">
        <li><a href="{% url 'semifinals:session-list' %}"><i class="las la-edit"></i><br><br>Épreuves écrites</a></li>
        <li><a href="{% url 'interviews:list' %}"><i class="las la-phone-volume"></i><br><br>Entretiens oraux</a></li>
        <li><a href="https://epreuve-machine.prologin.dev"><i class="las la-cube"></i><br><br>Site Épreuve Machine</a></li>
        <li><a href="{% url 'semifinals:logout' %}"><i class="las la-door-open"></i><br><br>Déconnexion</a></li>
        {% if settings.APP_SHOW_PIZZA_ICON %}
        <li><a href="https://youtu.be/dQw4w9WgXcQ?t=43"><i class="las la-pizza-slice"></i><br><br>Retrait des pizzas</a></li>
        {% endif %}
    </ul>
</div>

{% endblock %}

valentin/semifinals/templates/semifinals/organizer-home.html
{% extends "semifinals/base.html" %}
{% load static %}

{% block base_extra_head %}
<title>Espace Organisateur</title>
<link rel="stylesheet" href="{% static 'semifinals/css/home.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <h1>Espace Organisateur</h1>

    <p>Bienvenue dans votre espace organisateur, <b>{{ user.first_name }} {{ user.last_name }}</b></p>

    <h2>Épreuves écrites</h2>

    <ul class="home-links">
        <li><a href="{% url 'semifinals:session-list' %}"><i class="las la-edit"></i><br><br>Épreuves écrites</a></li>
        <li><a href="{% url 'semifinals:session-overseer-list' %}"><i class="las la-binoculars"></i><br><br>Supervision d'épreuve</a></li>
        <li><a href="{% url 'written_exams:form-list' %}"><i class="las la-stream"></i><br><br>Formulaires</a></li>
    </ul>

    <h2>Entretiens oraux</h2>

    <ul class="home-links">
        <li><a href="{% url 'interviews:list' %}"><i class="las la-users"></i><br><br>Sessions d'entretiens</a></li>
        <li><a href="{% url 'interviews:profile' %}"><i class="las la-snowman"></i><br><br>Profil Organisateur</a></li>
    </ul>

    <h2>Mon Compte</h2>
    <ul class="home-links">
        <li><a href="{% url 'admin:index' %}"><i class="las la-cog"></i><br><br>Django Admin</a></li>
        <li><a href="{% url 'semifinals:contestant-home' %}"><i class="las la-otter"></i><br><br>Espace Candidat</a></li>
        <li><a href="{% url 'semifinals:logout' %}"><i class="las la-door-open"></i><br><br>Déconnexion</a></li>
    </ul>
</div>

{% endblock %}

valentin/semifinals/templates/semifinals/session-details.html
{% extends "semifinals/base.html" %}
{% load static semifinals_status %}

{% block base_extra_head %}
<title>{{ object.display_name }}</title>
<link rel="stylesheet" href="{% static 'semifinals/css/sessions.css' %}">
{% endblock %}

{% block content %}

<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:session-list' %}">&lt; &nbsp; Retour à la liste des convocations</a></small>
    <h1 class="small-bottom-margin trb">{{ object.display_name }}</h1>
    <small class="session-unique-id">{{ object.id }}</small>

    <h3 style="color: {% session_status_color object.status %};">{% session_status object.status %}</h2>

    <p><i class="las la-clock big-icon"></i> Début <b>{{ object.date_start | date:"d F Y"}} à {{ object.date_start | date:"H:i:s"}}</b></p>
    <p><i class="las la-clock big-icon"></i> Fin <b>{{ object.date_end | date:"d F Y"}} à {{ object.date_end | date:"H:i:s"}}</b></p>

    <h2>Sujet et instructions</h2>

    <section id="subject-and-instructions">
        {% if object.status == 2 %}
        <p>{{ object.contestant_instructions | linebreaks | urlize }}</p>
            {% if object.subject %}
                <a href="{% url 'semifinals:download-subject' object.id %}" target="_blank" class="btn btn-secondary btn-block">TELECHARGER LE SUJET</a>
            {% endif %}
        {% else %}
        <h4>L'épreuve est fermée, vous ne pouvez plus accéder au sujet.</h4>
        {% endif %}
    </section>

    {% if object.form %}
        <h2>Formulaire de réponse</h2>
        {% if object.status == 2 %}
            <p>Cette épreuve comporte un formulaire de réponse, lisez les instructions et le sujet pour plus de détails.</p>
            <a href="{% url 'written_exams:form-questions' object.id %}" class="btn btn-block">OUVRIR LE FORMULAIRE DE RÉPONSE</a>
        {% else %}
            <p><b>L'épreuve est fermée, vous ne pouvez plus remplir le questionnaire.</b></p>
            {% if form_user_answers %}
                <div class="alert alert-success">Info: votre dernier rendu date du <b>{{ form_user_answers.last_updated | date:'d F Y à H:i:s' }}</b></div>
                {% if object.form_allow_review %}
                    <p><em>La relecture est autorisée pour cette épreuve, vous pouvez accéder à vos réponses en cliquant <a href="{% url 'written_exams:form-review' object.id %}">ici</a>.</em></p>
                {% endif %}
            {% else %}
                <div class="alert alert-warning">Info: vous n'avez jamais sauvegardé le formulaire de réponse.</div>
            {% endif %}
        {% endif %}
    {% endif %}

    {% if object.file_upload %}
        {% include 'written_exams/submission.html' %}
    {% endif %}
</div>

{% endblock %}

valentin/semifinals/templates/semifinals/session-list.html
{% extends "semifinals/base.html" %}
{% load semifinals_status static %}

{% block base_extra_head %}
<link rel="stylesheet" href="{% static 'semifinals/css/sessions.css' %}">
<title>Sessions</title>
{% endblock %}

{% block content %}

<div class="container">

    <small class="return-button"><a href="{% url 'semifinals:home' %}">&lt; &nbsp; Retour à l'accueil</a></small>
    <h1 class="trb">Mes sessions de demi-finale</h1>

    <section id="sessions-list">
        {% if object_list %}
        {% for session in object_list %}
        <article class="session-instance">
            <h3>{{ session.display_name }}</h3>
            <small class="session-unique-id">{{ session.id }}</small>
            <p>État : <span class="session-status" style="color: {% session_status_color session.status %};">{% session_status session.status %}</span></p>
            <p><i class="las la-clock"></i> Du <b>{{ session.date_start | date:"d F Y"}} à {{ session.date_start | date:"H:i:s"}}</b> au
            <b>{{ session.date_end | date:"d F Y"}} à {{ session.date_end | date:"H:i:s"}}</b></p>
            {% if session.status == 1%}
            <p>Dès que l'épreuve sera ouverte, vous pourrez accéder au sujet et à l'interface de rendu depuis cette page</p>
            {% endif %}
            <p class="session-status-message">{% session_status_message session.status %}</p>
            {% if session.status == 2 or session.status == 3 %}
            <a href="{% url 'semifinals:session-details' session.id %}" class="btn btn-block">OUVRIR</a>
            {% endif %}
        </article>
        {% endfor %}
        {% else %}
            <div class="text-center"><p>Vous n'êtes convoqué à aucune session d'épreuve écrite.</p></div>
        {% endif %}
    </section>

</div>

{% endblock %}

valentin/semifinals/templates/semifinals/session-overseer-list.html
{% extends 'semifinals/base.html' %}
{% load static %}

{% block base_extra_head %}
<title>Supervision Écrits</title>
<link rel="stylesheet" href="{% static 'semifinals/css/sessions.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:organizer-home' %}">&lt;&nbsp; Retour à l'espace organisateur</a></small>
    <h1 class="trb">Supervision Épreuve Écrite</h1>

    <section>
        {% if object_list %}
        {% for session in object_list %}
            <article class="session-instance">
                <div>
                    <h3>{{ session.display_name }}</h3>
                    <small class="session-unique-id">{{ session.id }}</small>
                </div>
                <div>
                    <br>
                    <a href="{% url 'semifinals:session-overseer' session.id %}" class="btn btn-success">ESPACE SUPERVISION</a>
                </div>
            </article>
        {% endfor %}
        {% else %}
            <p>Aucune épreuve disponible en supervision.</p>
        {% endif %}
    </section>
</div>
{% endblock %}

valentin/semifinals/templates/semifinals/session-overseer.html
{% extends 'semifinals/base.html' %}
{% load semifinals_status static %}

{% block base_extra_head %}
<title>Supervision d'épreuve</title>
<link rel="stylesheet" href="{% static 'semifinals/css/overseer.css' %}">
{% endblock %}

{% block content %}
<div class="container">
    <small class="return-button"><a href="{% url 'semifinals:session-overseer-list' %}">&lt;&nbsp; Retour à la liste des sessions</a></small>
    <h1 class="trb">Supervision d'épreuve</h1>
    <h4>{{ session.display_name }}</h4>
    <br>

    <table class="session-data">
        <tr>
            <td>Début </td>
            <td><b>{{ session.date_start | date:'d F Y à H:i:s' }}</b></td>
        </tr>
        <tr>
            <td>Fin </td>
            <td><b>{{ session.date_end | date:'d F Y à H:i:s' }}</b></td>
        </tr>
        <tr>
            <td>Statut</td>
            <td style="color: {% session_status_color session.status %};"><b>{% session_status session.status %}</b></td>
        </tr>
        <tr>
            <td>ID-ER Site Prologin</td>
            <td>{{ session.upstream_id }}</td>
        </tr>
        <tr>
            <td>Rendu de fichiers autorisé</td>
            <td>{{ session.file_upload }}</td>
        </tr>
        <tr>
            <td>Sujet</td>
            {% if session.subject %}
                {% if session.status == 2 %}
                    <td><a class="btn btn-block btn-secondary" href="{% url 'semifinals:download-subject' session.id %}">Télécharger</a></td>
                {% else %}
                    <td>True</td>
                {% endif %}
            {% else %}
            <td>Pas de sujet publié</td>
            {% endif %}
        </tr>
        <tr>
            <td>Formulaire</td>
            <td>
                {% if form %}
                ID : {{ form.id }} <br>
                Nom : {{ form.display_name }} <br>
                Chemin : {{ form.subject_path }}
                {% else %}
                Pas de formulaire attaché
                {% endif %}
            </td>
        </tr>
        <tr>
            <td>Relecture formulaire autorisée</td>
            <td>{{ session.form_allow_review }}</td>
        </tr>
    </table>
    <h2>Statistiques</h2>
    <p>Statistiques hors utilisateurs staff</p>
    <div class="stats">
        {% if form %}
        <div>
            <h4>Nb. de rendus formulaires</h4>
            <span>{{ nb_form_handouts }}</span>
        </div>
        {% endif %}
        {% if session.file_upload %}
        <div>
            <h4>Nb. de rendus de copies</h4>
            <span>{{ nb_file_handouts }}</span>
        </div>
        {% endif %}
        {% if session.subject %}
        <div>
            <h4>Nb. de téléchargements du sujet</h4>
            <span>{{ session.subject_download_count }}</span>
        </div>
        {% endif %}
    </div>


    {% if form %}
    <h2>15 derniers rendus formulaires</h2>
    <table class="last-handouts">
        <tr>
            <th>Utilisateur</th>
            <th>Date & Heure</th>
        </tr>
        {% for answer in last_form_handouts %}
        <tr>
            <td>{{ answer.user.first_name }} {{ answer.user.last_name }}</td>
            <td>{{ answer.last_updated | date:'d F Y à H:i:s' }}</td>
        </tr>
        {% endfor %}
    </table>
    {% endif %}

    {% if session.file_upload %}
    <h2>15 derniers rendus copies</h2>
    {% if perms.written_exams.can_export_submissions %}
    <a href="{% url 'written_exams:submissions-list' session.id %}" class="btn btn-block btn-secondary">
        Lister tous les rendus
    </a>
    {% endif %}
    <table class="last-handouts">
        <tr>
            <th>Utilisateur</th>
            <th>Date & heure</th>
        </tr>
        {% for file in last_file_handouts %}
        <tr>
            <td>{{ file.user.first_name }} {{ file.user.last_name }}</td>
            <td>{{ file.last_updated | date:'d F Y à H:i:s' }}</td>
        </tr>
        {% endfor %}
    </table>
    {% endif %}
</div>
{% endblock %}